import { getLocation, getMeteo, OpenWeatherAPIError } from "./weatherUtils.js";
const vueApp = Vue.createApp({
	data() {
		return {
			nomDeLieu: "",
			lieuxTrouvés: [],
			lieuSélectionné: null,
			météoLieuSélectionné: null,
			erreur: null,
		};
	},

	methods: {
		async findLocation() {
			console.log("chercher les coordonnées de " + this.nomDeLieu);
			// try {
			let res = await getLocation(this.nomDeLieu);
			this.lieuxTrouvés = res;
			if (this.lieuxTrouvés.length > 0) {
				await this.sélectionnerLieu(this.lieuxTrouvés[0]);
			} else {
				this.lieuSélectionné = null;
			}
			// } catch (err) {
			// 	console.log(err);
			// 	this.erreur = err;
			// }
		},
		async sélectionnerLieu(lieu) {
			// if (this.lieuSélectionné != null)
			if (this.lieuSélectionné) {
				this.lieuSélectionné.selected = false;
			}
			lieu.selected = true;
			this.lieuSélectionné = lieu;
			this.météoLieuSélectionné = await getMeteo(lieu);
		},
	},
});

vueApp.config.errorHandler = (err, instance, info) => {
	console.log("Erreur **************************************");
	console.log("Message : " + err.message);
	console.log(`vueApp.erreur : ${vueApp.erreur}`);
	console.log(`info : ${info}`);
	if (err instanceof OpenWeatherAPIError) {
		console.log("status code : " , err.status);
		console.log("status text : " + err.statusText);
		console.log("status url : " + err.url);
	}
    console.error(err);

	// vueApp.nomDeLieu = "Courch";
	// console.log("vueApp.nomDeLieu " + vm.nomDeLieu);
	// vm.erreur = err;
	const error = Vue.toRef(instance, "erreur");
	error.value = err;

	// // recupérer l'instance de la fenêtre modale pour l'affichage des erreurs
	// // et l'afficher
	const modal = bootstrap.Modal.getOrCreateInstance("#errorDialog");
	modal.show();
};

const vm = vueApp.mount("#app");

